#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Place_Component
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>CorG Tool>Place_Component
#		 Note:	
#			
#    Date:	Feb 2016
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Place_Component") { Sketchup.active_model.select_tool SDM::Place_Component.new }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	class Place_Component

		def initialize
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@sel=@mod.selection
			@ip=Sketchup::InputPoint.new
			@cdn = @mod.definitions.map{|d| d.name}
			self.reset
		end
		
		def reset
			@status_text = "Pick Location"; @status = 0; @nam ||= @cdn[0]; @bb = nil
			inp = UI.inputbox(["Component:"],[@nam],[@cdn.join("|")],"Place Component")
			if inp
				@nam = inp[0]; @cd = @mod.definitions[@nam]
				@bb = @cd.bounds; @status = 1
			else
				onCancel(nil,nil)
			end
		end
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh
			Sketchup::set_status_text @status_text,SB_PROMPT
		end
		
		def onLButtonDown(flags, x, y, view)
			if @status==1
				@ent.add_instance(@cd,@tr)
			end
		end
		
		def onRButtonDown(flags, x, y, view)
			@status==0 ? onCancel(flags,view) : self.reset
		end
		
		def onCancel(flags,view)
			Sketchup.active_model.active_view.refresh
			Sketchup.send_action "selectSelectionTool:"
		end
		 
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
			if @bb
				view.line_width = 3
				view.drawing_color = 'yellow'
				@tr = Geom::Transformation.new(@ip.position); pts = []
				(0..7).each{|i| pts << @bb.corner(i).transform(@tr)}
				view.draw GL_LINE_LOOP,pts[0],pts[1],pts[3],pts[2]
				view.draw GL_LINE_LOOP,pts[4],pts[5],pts[7],pts[6]
				(0..3).each{|i| view.draw_line pts[i],pts[i+4]}
			end
		end
		
	end
	
end
